Skip to content
Start here

List IP Access rules

client.firewall.accessRules.list(AccessRuleListParams { account_id, zone_id, configuration, 7 more } params?, RequestOptionsoptions?): V4PagePaginationArray<AccessRuleListResponse { id, allowed_modes, configuration, 5 more } >
GET/{accounts_or_zones}/{account_or_zone_id}/firewall/access_rules/rules

Fetches IP Access rules of an account or zone. These rules apply to all the zones in the account or zone. You can filter the results using several optional parameters.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Account Firewall Access Rules WriteAccount Firewall Access Rules Read
ParametersExpand Collapse
params: AccessRuleListParams { account_id, zone_id, configuration, 7 more }
account_id?: string

Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID.

zone_id?: string

Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID.

configuration?: Configuration

Query param

target?: "ip" | "ip_range" | "asn" | "country"

Defines the target to search in existing rules.

One of the following:
"ip"
"ip_range"
"asn"
"country"
value?: string

Defines the target value to search for in existing rules: an IP address, an IP address range, or a country code, depending on the provided configuration.target. Notes: You can search for a single IPv4 address, an IP address range with a subnet of '/16' or '/24', or a two-letter ISO-3166-1 alpha-2 country code.

direction?: "asc" | "desc"

Query param: Defines the direction used to sort returned rules.

One of the following:
"asc"
"desc"
match?: "any" | "all"

Query param: Defines the search requirements. When set to all, all the search requirements must match. When set to any, only one of the search requirements has to match.

One of the following:
"any"
"all"
mode?: "block" | "challenge" | "whitelist" | 2 more

Query param: The action to apply to a matched request.

One of the following:
"block"
"challenge"
"whitelist"
"js_challenge"
"managed_challenge"
notes?: string

Query param: Defines the string to search for in the notes of existing IP Access rules. Notes: For example, the string 'attack' would match IP Access rules with notes 'Attack 26/02' and 'Attack 27/02'. The search is case insensitive.

order?: "configuration.target" | "configuration.value" | "mode"

Query param: Defines the field used to sort returned rules.

One of the following:
"configuration.target"
"configuration.value"
"mode"
page?: number

Query param: Defines the requested page within paginated list of results.

per_page?: number

Query param: Defines the maximum number of results requested.

ReturnsExpand Collapse
AccessRuleListResponse { id, allowed_modes, configuration, 5 more }
id: string

The unique identifier of the IP Access rule.

maxLength32
allowed_modes: Array<"block" | "challenge" | "whitelist" | 2 more>

The available actions that a rule can apply to a matched request.

One of the following:
"block"
"challenge"
"whitelist"
"js_challenge"
"managed_challenge"
configuration: AccessRuleIPConfiguration { target, value } | IPV6Configuration { target, value } | AccessRuleCIDRConfiguration { target, value } | 2 more

The rule configuration.

One of the following:
AccessRuleIPConfiguration { target, value }
target?: "ip"

The configuration target. You must set the target to ip when specifying an IP address in the rule.

value?: string

The IP address to match. This address will be compared to the IP address of incoming requests.

IPV6Configuration { target, value }
target?: "ip6"

The configuration target. You must set the target to ip6 when specifying an IPv6 address in the rule.

value?: string

The IPv6 address to match.

AccessRuleCIDRConfiguration { target, value }
target?: "ip_range"

The configuration target. You must set the target to ip_range when specifying an IP address range in the rule.

value?: string

The IP address range to match. You can only use prefix lengths /16 and /24 for IPv4 ranges, and prefix lengths /32, /48, and /64 for IPv6 ranges.

ASNConfiguration { target, value }
target?: "asn"

The configuration target. You must set the target to asn when specifying an Autonomous System Number (ASN) in the rule.

value?: string

The AS number to match.

CountryConfiguration { target, value }
target?: "country"

The configuration target. You must set the target to country when specifying a country code in the rule.

value?: string

The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to IP Access rules: Parameters.

mode: "block" | "challenge" | "whitelist" | 2 more

The action to apply to a matched request.

One of the following:
"block"
"challenge"
"whitelist"
"js_challenge"
"managed_challenge"
created_on?: string

The timestamp of when the rule was created.

formatdate-time
modified_on?: string

The timestamp of when the rule was last modified.

formatdate-time
notes?: string

An informative summary of the rule, typically used as a reminder or explanation.

scope?: Scope { id, email, type }

All zones owned by the user will have the rule applied.

id?: string

Defines an identifier.

maxLength32
email?: string

The contact email address of the user.

maxLength90
type?: "user" | "organization"

Defines the scope of the rule.

One of the following:
"user"
"organization"

List IP Access rules

import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

// Automatically fetches more pages as needed.
for await (const accessRuleListResponse of client.firewall.accessRules.list({
  account_id: 'account_id',
})) {
  console.log(accessRuleListResponse.id);
}
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "id": "92f17202ed8bd63d69a66b86a49a8f6b",
      "allowed_modes": [
        "whitelist",
        "block",
        "challenge",
        "js_challenge",
        "managed_challenge"
      ],
      "configuration": {
        "target": "ip",
        "value": "198.51.100.4"
      },
      "mode": "challenge",
      "created_on": "2014-01-01T05:20:00.12345Z",
      "modified_on": "2014-01-01T05:20:00.12345Z",
      "notes": "This rule is enabled because of an event that occurred on date X.",
      "scope": {
        "id": "023e105f4ecef8ad9ca31a8372d0c353",
        "email": "user@example.com",
        "type": "user"
      }
    }
  ],
  "success": true,
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "id": "92f17202ed8bd63d69a66b86a49a8f6b",
      "allowed_modes": [
        "whitelist",
        "block",
        "challenge",
        "js_challenge",
        "managed_challenge"
      ],
      "configuration": {
        "target": "ip",
        "value": "198.51.100.4"
      },
      "mode": "challenge",
      "created_on": "2014-01-01T05:20:00.12345Z",
      "modified_on": "2014-01-01T05:20:00.12345Z",
      "notes": "This rule is enabled because of an event that occurred on date X.",
      "scope": {
        "id": "023e105f4ecef8ad9ca31a8372d0c353",
        "email": "user@example.com",
        "type": "user"
      }
    }
  ],
  "success": true,
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}